-- name: [CS] SMG4 Crew
-- description: The Funny Youtube Machinima Crew is here in SM64 Coop Deluxe! Play as one of 3 Characters from the SMG4 Series and explore as your favorite bois!\n\n\Modpack by VioletArts\n\n\SMG4 along with other characters included belongs to SMG4 and Glitch Productions
-- deluxe: true
local globalModName = "SMG4 Crew";

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_MEGGY_MODEL = smlua_model_util_get_id("meggy_violet_geo");
local E_SMG4_MODEL = smlua_model_util_get_id("smg4_violet_geo");
local E_SMG3_MODEL = smlua_model_util_get_id("smg3_violet_geo");
local E_TARI_MODEL = smlua_model_util_get_id("tari_violet_geo");

local TEX_MEGGY_LIFE_ICON = get_texture_info("meggy_violet_icon")
local TEX_SMG4_LIFE_ICON = get_texture_info("smg4_violet_icon")
local TEX_SMG3_LIFE_ICON = get_texture_info("smg3_violet_icon")
local TEX_TARI_LIFE_ICON = get_texture_info("tari_violet_icon")

local VOICETABLE_MEGGY = {
    [CHAR_SOUND_ATTACKED] = 'MeggyAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'MeggyCough.ogg',
    [CHAR_SOUND_DOH] = 'MeggyDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'MeggyDrown.ogg',
    [CHAR_SOUND_DYING] = 'MeggyDead.ogg',
    [CHAR_SOUND_EEUH] = 'MeggyEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'MeggyGroundPound.ogg',
    [CHAR_SOUND_HAHA] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'MeggyHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'MeggyWoomy.ogg',
    [CHAR_SOUND_HOOHOO] = 'MeggyYahaJump.ogg',
    [CHAR_SOUND_HRMM] = 'MeggyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'MeggyTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'MeggyLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'MeggyComeOn.ogg',
    [CHAR_SOUND_ON_FIRE] = 'MeggyBurning.ogg',
    [CHAR_SOUND_OOOF] = 'MeggyOof.ogg',
    [CHAR_SOUND_OOOF2] = 'MeggyOof.ogg',
    [CHAR_SOUND_PANTING] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'MeggyPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'MeggyHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'MeggyWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'MeggyYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'MeggySnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'MeggySnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'MeggyBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'MeggyBoing.ogg',
    [CHAR_SOUND_UH] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2] = 'MeggyUh.ogg',
    [CHAR_SOUND_UH2_2] = 'MeggyUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'MeggyYell.ogg',
    [CHAR_SOUND_WHOA] = 'MeggyWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'MeggyYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'MeggyYahoo.ogg', 'MeggyWaha.ogg', 'MeggyYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'MeggyYahJump.ogg', 'MeggyWahJump.ogg', 'MeggyHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'MeggyYawn.ogg',
}

local VOICETABLE_TARI = {
    [CHAR_SOUND_ATTACKED] = 'TariAttacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'TariCough.ogg',
    [CHAR_SOUND_DOH] = 'TariDoh.ogg',
    [CHAR_SOUND_DROWNING] = 'TariDrown.ogg',
    [CHAR_SOUND_DYING] = 'TariDead.ogg',
    [CHAR_SOUND_EEUH] = 'TariEeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'TariWahPunch.ogg',
    [CHAR_SOUND_HAHA] = 'TariHaha.ogg',
    [CHAR_SOUND_HAHA_2] = 'TariHaha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'TariHereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'TariHoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'MeggyGrab.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'TariTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'TariLetsDoThis.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'TariOhNo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'TariBurning.ogg',
    [CHAR_SOUND_OOOF] = 'TariOof.ogg',
    [CHAR_SOUND_OOOF2] = 'TariOof.ogg',
    [CHAR_SOUND_PANTING] = 'TariPanting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'TariPanting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'TariHooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'TariWahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'TariYahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'TariSnore1.ogg',
    [CHAR_SOUND_SNORING2] = 'TariSnore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'TariBowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'TariBoing.ogg',
    [CHAR_SOUND_UH] = 'TariUh.ogg',
    [CHAR_SOUND_UH2] = 'TariUh.ogg',
    [CHAR_SOUND_UH2_2] = 'TariUh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'TariFall.ogg',
    [CHAR_SOUND_WHOA] = 'TariWoah.ogg',
    [CHAR_SOUND_YAHOO] = 'TariYahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TariYahoo.ogg', 'TariWaha.ogg', 'TariYippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'TariYahJump.ogg', 'TariWahJump.ogg', 'TariHooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'TariYawn.ogg',
}

local VOICETABLE_SMG4 = {
    [CHAR_SOUND_ATTACKED] = 'SMG4Attacked.ogg',
    [CHAR_SOUND_COUGHING3] = 'SMG4Cough.ogg',
    [CHAR_SOUND_DOH] = 'SMG4Doh.ogg',
    [CHAR_SOUND_DROWNING] = 'SMG4Drown.ogg',
    [CHAR_SOUND_DYING] = 'SMG4Dead.ogg',
    [CHAR_SOUND_EEUH] = 'SMG4Eeuh.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'SMG4GroundPoundWah.ogg',
    [CHAR_SOUND_HAHA] = 'SMG4Haha.ogg',
    [CHAR_SOUND_HAHA_2] = 'SMG4Haha.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'SMG4HereWeGo.ogg',
    [CHAR_SOUND_HOOHOO] = 'SMG4Hoohoo.ogg',
    [CHAR_SOUND_HRMM] = 'SMG4Hrmm.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'SMG4ImTired.ogg',
    [CHAR_SOUND_LETS_A_GO] = 'SMG4LetsAGo.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'SMG4GodDammit.ogg',
    [CHAR_SOUND_ON_FIRE] = 'SMG4Burning.ogg',
    [CHAR_SOUND_OOOF] = 'SMG4Oof.ogg',
    [CHAR_SOUND_OOOF2] = 'SMG4Oof.ogg',
    [CHAR_SOUND_PANTING] = 'SMG4Panting.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'SMG4Panting.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'SMG4HooKick.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'SMG4WahPunch.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'SMG4YahPunch.ogg',
    [CHAR_SOUND_SNORING1] = 'SMG4Snore1.ogg',
    [CHAR_SOUND_SNORING2] = 'SMG4Snore2.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'SMG4Bowser.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'SMG4Boing.ogg',
    [CHAR_SOUND_UH] = 'SMG4Uh.ogg',
    [CHAR_SOUND_UH2] = 'SMG4Uh.ogg',
    [CHAR_SOUND_UH2_2] = 'SMG4Uh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'SMG4Fall.ogg',
    [CHAR_SOUND_WHOA] = 'SMG4Woah.ogg',
    [CHAR_SOUND_YAHOO] = 'SMG4Yahoo.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'SMG4Yahoo.ogg', 'SMG4Waha.ogg', 'SMG4Yippee.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'SMG4YahJump.ogg', 'SMG4WahJump.ogg', 'SMG4HooJump.ogg'},
    [CHAR_SOUND_YAWNING] = 'SMG4Yawn.ogg',
}

local MEGGY_CAPMODELS = {
    normal = smlua_model_util_get_id("meggy_violet_cap_geo"),
    wing = smlua_model_util_get_id("meggy_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("meggy_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("meggy_violet_cap_metal_wing_geo"),
}

local SMG4_CAPMODELS = {
    normal = smlua_model_util_get_id("smg4_violet_cap_geo"),
    wing = smlua_model_util_get_id("smg4_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("smg4_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("smg4_violet_cap_metal_wing_geo"),
}

local SMG3_CAPMODELS = {
    normal = smlua_model_util_get_id("smg3_violet_cap_geo"),
    wing = smlua_model_util_get_id("smg3_violet_cap_wing_geo"),
    metal = smlua_model_util_get_id("smg3_violet_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("smg3_violet_cap_metal_wing_geo"),
}

local MEGGY_PALETTE = {
    [PANTS] = "494949",
    [SHIRT] = "FFFFFF",
    [GLOVES] = "525A4C",
    [SHOES] = "503325",
    [HAIR] = "FF9035",
    [SKIN] = "FFBF8D",
    [CAP] = "E4302A",
    [EMBLEM] = "7C8D6F"
}

local SMG4_PALETTE = {
    [PANTS] = "FFFFFF",
    [SHIRT] = "3700F6",
    [GLOVES] = "FFFFFF",
    [SHOES] = "694A2E",
    [HAIR] = "202028",
    [SKIN] = "FEC179",
    [CAP] = "3700F6",
    [EMBLEM] = "3700F6"
}

local SMG3_PALETTE = {
    [PANTS] = "232133",
    [SHIRT] = "4F14A3",
    [GLOVES] = "FFFFFF",
    [SHOES] = "202028",
    [HAIR] = "202028",
    [SKIN] = "FEC179",
    [CAP] = "4F14A3",
    [EMBLEM] = "FFFFFF"
}

local TARI_PALETTE = {
    [PANTS] = "9B8A71",
    [SHIRT] = "3B90E5",
    [GLOVES] = "49484D",
    [SHOES] = "FFFFFF",
    [HAIR] = "4789EA",
    [SKIN] = "FFCDA8",
    [CAP] = "E4302A",
    [EMBLEM] = "877A65"
}

local charSelectExists = false
local function on_character_select_load()
    CT_MEGGY = _G.charSelect.character_add("Meggy Spletzer", {"Splatfest Champ, former Inkling, bad cook, whatever", "you'd like to call her, Meggy Spletzer makes her", "appearance in SM64, as she helps Mario and friends", "defeat the great Bowser!", "", "Voice by SaltedPearls"}, "VioletArts", {r = 255, g = 144, b = 53}, E_MEGGY_MODEL, CT_MARIO, TEX_MEGGY_LIFE_ICON)
    _G.charSelect.character_add_caps(E_MEGGY_MODEL, MEGGY_CAPMODELS)
    _G.charSelect.character_add_voice(E_MEGGY_MODEL, VOICETABLE_MEGGY)
    _G.charSelect.character_add_palette_preset(E_MEGGY_MODEL, MEGGY_PALETTE)

    CT_SMG4 = _G.charSelect.character_add("SMG4", {"The Meme Boi has arrived in the Mushroom Kingdom!", "What kinds of crazy antics will he go on", "as he uses the power of memes to save the day!", "", "Voiced by Malik Radwan"}, "SM64Rise", {r = 55, g = 0, b = 246}, E_SMG4_MODEL, CT_MARIO, TEX_SMG4_LIFE_ICON)
    _G.charSelect.character_add_caps(E_SMG4_MODEL, SMG4_CAPMODELS)
    _G.charSelect.character_add_voice(E_SMG4_MODEL, VOICETABLE_SMG4)
    _G.charSelect.character_add_palette_preset(E_SMG4_MODEL, SMG4_PALETTE)

    CT_SMG3 = _G.charSelect.character_add("SMG3", {"Heroes beware, the former villain and protector", "of the Internet Graveyard is here to wreck havoc", "upon the Mushroom Kingdom, but I guess it wouldn't", "be too bad to help a couple friends out...", ""}, "SM64Rise", {r = 79, g = 20, b = 163}, E_SMG3_MODEL, CT_MARIO, TEX_SMG3_LIFE_ICON)
    _G.charSelect.character_add_caps(E_SMG3_MODEL, SMG3_CAPMODELS)
    _G.charSelect.character_add_palette_preset(E_SMG3_MODEL, SMG3_PALETTE)

    CT_TARI = _G.charSelect.character_add("Tari", {"The gaming girl extrodinare, Tari, makes her", "appearance in SM64, will she overcome her", "cowardice and help her friends defeat the great", "Bowser? Or will there be more trouble that occurs?", "", "Voiced by AlessaW/VAButterfly"}, "Yuyake", {r = 59, g = 144, b = 229}, E_TARI_MODEL, CT_MARIO, TEX_TARI_LIFE_ICON)
    _G.charSelect.character_add_voice(E_TARI_MODEL, VOICETABLE_TARI)
    _G.charSelect.character_add_voice(E_TARI_MODEL, VOICETABLE_TARI)
    _G.charSelect.character_add_palette_preset(E_TARI_MODEL, TARI_PALETTE)

    charSelectExists = true
end

local function on_character_sound(m, sound)
    if not charSelectExists then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGY then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TARI then return _G.charSelect.voice.sound(m, sound) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG4 then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not charSelectExists then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_MEGGY then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TARI then return _G.charSelect.voice.snore(m) end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SMG4 then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)